TYPE_PRINCIPAL = "principal"
TYPE_ADDRESSBOOK = "addressbook"

PRINCIPAL_TYPE_USER = 1
PRINCIPAL_TYPE_GROUP = 2

STATUS_INVITED = 0
STATUS_DECLINED = 1
STATUS_ACCEPTED = 2

PRIV_READ = 0
PRIV_WRITE = 1
PRIV_MANAGE = 2
PRIV_OWN = 3
PRIV_GROUP = 4
PRIV_GROUP_READ = 5
PRIV_GROUP_WRITE = 6
PRIV_GROUP_MANAGE = 7

ADDRESSBOOK_TYPE_PUBLIC = 0
ADDRESSBOOK_TYPE_NORMAL = 1
ADDRESSBOOK_TYPE_SUGGESTED = 2
ADDRESSBOOK_TYPE_DEFAULT = 3
ADDRESSBOOK_TYPE_DEFAULT_PUBLIC = 4
ADDRESSBOOK_TYPE_EXTERNAL_SOURCE = 5

ADDRESSBOOK_OBJECT_KIND_PERSON = 0
ADDRESSBOOK_OBJECT_KIND_GROUP = 1

PATH_ROOT_COLLECTION = "/"

SYNC_TOKEN_PREFIX = "http://radicale.org/ns/sync/"

VCF_SUFFIX = ".vcf"

PROP_TAG = "tag"

PROP_ADDRESSBOOK_DISPLAY_NAME = "D:displayname"
PROP_ADDRESSBOOK_DESCRIPTION = "CR:addressbook-description"
PROP_ADDRESSBOOK_COLOR = "{http://inf-it.com/ns/ab/}addressbook-color"
ADDRESSBOOK_TAG = "VADDRESSBOOK"

VCARD_PROPS_FULL_NAME = ["fn"]
VCARD_PROPS_ORG = ["org"]
VCARD_PROPS_TITLE = ["title"]
VCARD_PROPS_EMAIL = ["email"]
VCARD_PROPS_TEL = ["tel"]
VCARD_PROPS_DATE = ["x-abdate"]
VCARD_PROPS_BDAY = ["bday"]
VCARD_PROPS_PHOTO = ["photo"]

VCARD_PROPS_NAMES = ["n"]
VCARD_PROPS_PHONETIC_FIRST_NAME = ["x-phonetic-first-name"]
VCARD_PROPS_PHONETIC_MIDDLE_NAME = ["x-phonetic-middle-name"]
VCARD_PROPS_PHONETIC_LAST_NAME = ["x-phonetic-last-name"]
VCARD_PROPS_NICKNAME = ["nickname"]
VCARD_PROPS_ADR = ["adr"]
VCARD_PROPS_URL = ["url"]
VCARD_PROPS_NOTE = ["note"]
VCARD_PROPS_IM = [
    # vcard spec
    "impp",
    # google format, custom ims has format like "x-custom-name", so we can't predefine here
    "x-aim",
    "x-yahoo",
    "x-skype",
    "x-qq",
    # apple format
    "x-jabber",
    "x-msn",
    "x-icq"
]
VCARD_PROPS_KIND = ["x-addressbookserver-kind"]

VCARD_PROPS_PREFER_TYPES = ["pref", "main"]

ABO_SEARCH_TOKEN_TYPE_FULL_NAME = 0
ABO_SEARCH_TOKEN_TYPE_GIVEN_NAME = 1
ABO_SEARCH_TOKEN_TYPE_MIDDLE_NAME = 2
ABO_SEARCH_TOKEN_TYPE_FAMILY_NAME = 3
ABO_SEARCH_TOKEN_TYPE_JOB_TITLE = 4
ABO_SEARCH_TOKEN_TYPE_DEPARTMENT = 5
ABO_SEARCH_TOKEN_TYPE_COMPANY = 6
ABO_SEARCH_TOKEN_TYPE_EMAIL = 7
ABO_SEARCH_TOKEN_TYPE_TEL = 8
ABO_SEARCH_TOKEN_TYPE_ADR = 9
ABO_SEARCH_TOKEN_TYPE_URL = 10
ABO_SEARCH_TOKEN_TYPE_DATE = 11
ABO_SEARCH_TOKEN_TYPE_IM = 12
ABO_SEARCH_TOKEN_TYPE_PHONETIC_GIVEN_NAME = 13
ABO_SEARCH_TOKEN_TYPE_PHONETIC_MIDDLE_NAME = 14
ABO_SEARCH_TOKEN_TYPE_PHONETIC_FAMILY_NAME = 15
ABO_SEARCH_TOKEN_TYPE_NICKNAME = 16
ABO_SEARCH_TOKEN_TYPE_NOTE = 17

SYNO_LIB_PATH = "/var/packages/Contacts/target/lib/libsynocontactscore.so"
SYNO_MAX_USERNAME_LENGTH = 1024
