import radicale.syno.constant as constant


def is_own(mode):
    return mode == constant.PRIV_OWN


def is_manageable(mode):
    return mode == constant.PRIV_MANAGE or mode == constant.PRIV_GROUP_MANAGE or is_own(
        mode
    )


def is_writable(mode):
    return mode == constant.PRIV_WRITE or mode == constant.PRIV_GROUP_WRITE or is_manageable(
        mode
    )


def is_readable(mode):
    return mode == constant.PRIV_READ or mode == constant.PRIV_GROUP_READ or is_writable(
        mode
    )


def is_greater(lh, rh):
    return is_own(lh) or (
        is_manageable(lh) and not is_manageable(rh)) or (
        is_writable(lh) and not is_writable(rh)) or (
        is_readable(lh) and not is_readable(rh)) or \
        rh == constant.PRIV_GROUP
